'*******************************************************************************
'
'                    Spannungs- und  Strommessung mit LTC1298
'
' - galvanisch voneinander getrennte 12bit AD Wandler
' - Temperaturmessung mit PWM gesteuerten Lfter
'
'
'  Entworfen von Marcus Pool
'  www.marcus-pool.de
'
' Beim Programmieren JTAG deaktivieren sonst luft der Temperatursensor nicht !!
' Durch Oversampling wird eine Genaugkeit von 14bit erreicht. s.a. Atmel Application
' Note 121.
'*******************************************************************************
$regfile = "m16def.dat"
'$regfile = "8515def.dat"
$crystal = 4000000
$swstack = 16

Dim A As Byte
Dim I As Byte
Dim Temp As Byte
Dim Adc_wert As Word
Dim Adc_gesamt As Long
Dim Stelle As Byte
Dim Bereich As Byte                                         ' dient zum Erkennen von Lfterstufe

Dim Z As String * 8
Dim Lcdwert As Single
Dim Spannung As Bit                                         ' 1 = Spannungsmessen, 0 = Strom
Dim Seite As Bit                                            ' 1 = links, 0 = rechts

Declare Sub Read1820
Declare Sub Temperature
Dim Bd(9) As Byte
Dim Tmp As Byte
Dim T As Integer
Dim T1 As Integer
Dim T2 As Single

Config Lcd = 20 * 2
Config Lcdpin = Pin , Db4 = Portd.0 , Db5 = Portd.1 , Db6 = Portd.2 , Db7 = Portd.3 , E = Portb.6 , Rs = Portb.5
Cursor Off Noblink                                          'kein blinken des Cursors
Config 1wire = Portc.4

Config Timer1 = Pwm , Prescale = 1 , Pwm = 8 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down
Compare1a = 50
Enable Interrupts
Enable Timer1
Deflcdchar 0 , 32 , 32 , 32 , 32 , 32 , 32 , 32 , 4         ' Lfterstufe 1
Deflcdchar 1 , 32 , 32 , 32 , 32 , 32 , 32 , 4 , 14         ' Lfterstufe 2
Deflcdchar 2 , 32 , 32 , 32 , 32 , 32 , 4 , 14 , 31         ' Lfterstufe 3
Temp = 0


Config Pina.5 = Output
   Din Alias Porta.5
Config Pinb.3 = Output
   Shdn Alias Portb.3
Config Pinb.4 = Output
   Clk Alias Portb.4
Config Pina.4 = Input
   Dout Alias Pina.4

'*******************************************************************************
' Start und Initialisierung
'*******************************************************************************
Compare1a = 255
Cls
Home
Lcd "Labornetzteil 0-30V"
Lowerline
Lcd "    Marcus Pool"
Wait 1
Cls
Home
Lcd "U: xx.xxV U: xx.xxV"
Lowerline
Lcd "A: x.xxxA A: x.xxxA"


'*******************************************************************************
' Main Programm
'*******************************************************************************

Stelle = 1
Main:
   Select Case Stelle
      Case 1                                                'Linke Seite Spannung messen
         Shdn = 0
         Waitus 10
         Shdn = 1
         A = 208                                            'Einstellungen fr A/D Wandler
         Spannung = 1
         Locate 1 , 4
         Seite = 1
     Case 2                                                 'Linke Seite Strom messen
         Shdn = 0
         Waitus 10
         Shdn = 1
         A = 240                                            'Einstellungen fr A/D Wandler
         Spannung = 0
         Locate 2 , 4
         Seite = 1
      Case 3                                                'Rechte Seite Spannung messen
         Shdn = 1
         Waitus 10
         Shdn = 0
         A = 208                                            'Einstellungen fr A/D Wandler
         Spannung = 1
         Locate 1 , 14
         Seite = 0
      Case 4                                                'Rechte Seite Strom messen
         Shdn = 1
         Waitus 10
         Shdn = 0
         A = 240                                            'Einstellungen fr A/D Wandler
         Spannung = 0
         Locate 2 , 14
         Seite = 0
   End Select

   For I = 1 To 16
      If Seite = 1 Then                                     'aktiviere gewhlte Seite
         Set Shdn
      Else
         Reset Shdn
      End If
      Shiftout Din , Clk , A , 0 , 6 , 200                  'Einstellung des AD Wandlers
      Shiftin Dout , Clk , Adc_wert , 1 , 16 , 200          'Daten auslesen
      If Seite = 1 Then                                     'deaktivieren gewhlte Seite
         Reset Shdn
      Else
         Set Shdn
      End If
      Shift Adc_wert , Right , 4
      Adc_gesamt = Adc_gesamt + Adc_wert                    'addieren der 16 Samples
   Next
   Shift Adc_gesamt , Right , 2                             'ADC_Gesamt geteilt durch 4 um auf 14 bit Auflsung zu kommen
   Gosub Format_lcd
   Incr Stelle                                              'nchsten Wandler anpsrechen
   If Stelle = 5 Then                                       'wenn alle 4 A/D Wandler durch dann neu starten
      Gosub Temperatur
      Stelle = 1
   End If
Goto Main

'*******************************************************************************
' Formatieren der LCD Anzeige fr Spannung und Strom
'*******************************************************************************
Format_lcd:
If Spannung = 1 Then
   If Seite = 1 Then                                        'linke Seite Korrektur
      Lcdwert = Adc_gesamt / 542.879
   Else                                                     'rechte Seite Korrektur
      Lcdwert = Adc_gesamt / 544
   End If
   Z = Fusing(lcdwert , "##.##")                            'Anzeige mit einer Vor- und Nachkommastelle
   Z = Format(z , "     ")
Else
   If Seite = 1 Then                                        'linke Seite Korrektur
      Lcdwert = Adc_gesamt / 3365
      '      Lcdwert = Adc_gesamt / 3347.28
   Else                                                     'rechte Seite Korrektur
      Lcdwert = Adc_gesamt / 3230
'            Lcdwert = Adc_gesamt / 3237.9
   End If
   Z = Fusing(lcdwert , "#.###")                            'Anzeige mit einer Vor- und Nachkommastelle
End If
Lcd Z
Adc_gesamt = 0
Return

'*******************************************************************************
' PWM nach Temperatur einstellen
'*******************************************************************************
Temperatur:
   1wwrite &HCC : 1wwrite &H44                              'starte Messung
   Waitms 250                                               'warten auf Ende der Messung
   Read1820                                                 'lesen der 9 bits

Select Case T2                                              'einstellen der PWM fr den Lfter
       Case Is < 30:
            Compare1a = 0
            Locate 2 , 10
            Lcd " "
            Temp = 0
       Case 30 To 40:
            Compare1a = 100
            Locate 2 , 10
            Lcd Chr(0)
            If Temp = 1 Then                                ' PWM erste Stufe
               Compare1a = 100
            End If
            If Temp = 0 Then                                ' Lfter voll an fr kurze Zeit zum
               Compare1a = 255                              ' anlaufen lassen. Nur wenn Temperatur
               Temp = 1                                     ' steigt.
            End If
            If Temp = 3 Then
               Temp = 1
               Compare1a = 100
            End If
       Case 40 To 50:
            Compare1a = 200
            Locate 2 , 10
            Lcd Chr(1)
       Case 50 To 52:
            Compare1a = 255
            Locate 2 , 10
            Lcd Chr(2)
       Case Is > 55:
            Compare1a = 255
            Locate 2 , 10
            Lcd "!"
End Select


'*******************************************************************************
' DS1820 auslesen
'*******************************************************************************

Sub Read1820                                                ' reads sensor and calculate
                                                            ' T for 0.1 C
   1wreset                                                  ' reset the bus
   1wwrite &HCC                                             ' read internal RAM
   1wwrite &HBE                                             ' read 9 data bytes
   Bd(1) = 1wread(9)                                        ' read bytes in array
   1wreset                                                  ' reset the bus
     Tmp = Bd(1) And 1                                      ' 0.1C precision
      If Tmp = 1 Then Decr Bd(1)
      T = Makeint(bd(1) , Bd(2))
      T = T * 50
      T = T - 25
      T1 = Bd(8) - Bd(7)
      T1 = T1 * 100
      T1 = T1 / Bd(8)
      T2 = T
      T2 = T2 + T1
      T2 = T2 / 100
End Sub